/*============================================================================
̧ٖ	: $Workfile: main.h $
	: AVR252: TVڐGް
ړI	: ײ؊֐ƕϐ̒`
ײ	: v1.1
------------------------------------------------------------------------------
Ŕԍ		: $Revision: 4.3 $
ŏIXV	: $Date: 2009-08-20 09:50:27 +05:30 $
XV		: $Author: ATMEL $
------------------------------------------------------------------------------
쌠 (c) 2009 Atmel Ltd. S\ς
------------------------------------------------------------------------------
̧قAtmel Ltd.̊Ƌ@܂݂܂B͂莦ꂽAtmel Ltd.̋\
ȂŁA޲͂ǂȎiɂA܂͉̖ړÎ߂ɁAǂ̌`łʂ܂
͓nȂ܂B
============================================================================*/

#ifndef __MAIN_H__
#define __MAIN_H__

/*----------------------------------------------------------------------------
  : ײؔł̑I
------------------------------------------------------------------------------
QTouchײ؂͏[dԂ͈̔͂Ƌɍ\zċ܂B[dԂ͏[dAVR
瑪eʏֈړ]ԂłBZԂ͂葬ɋA܂A
eʏ֏[dSɈړ]̂ɑ邩܂B

[dԂ͈̔͂͂߂sۯxɓKłgp҂ɑI΂܂B

ײؖ`<>_<ِ>_<cX>_<@\>.r90łB

Ⴆ: m88_8qt_c3_krs.r90ATmega88(m88)A8QTouch(8qt)A3̏[d
(c3)A-Ɖ]Ɛx(krs)܂B

eʐs߁A\I0.25`2.5sx̏[dԂKvƂ܂Bȉ
̕\͸ۯx͈̔͂ɑΉ[dԂ܂B

ۯx(MHz)	(s)	K[d
-------------	-------------	---------------------
	 1				1			1` 2 (1`2s)
	 2				0.5			1` 5 (0.5`2.5s)
	 4				0.25		1`10 (0.25`2.5s)
	 8				0.125		2`10 (0.25`1.25s)
	10				0.1			3`25 (0.3`2.5s)
	16				0.0625		4`25 (0.25`1.5625s)
	20				0.05		5`50 (0.25`2.5s)

----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  qɂꂽݸٰ ̧
----------------------------------------------------------------------------*/
#include <ioavr.h>
#include <intrinsics.h>
#include <stdbool.h>

/*----------------------------------------------------------------------------
  萔
----------------------------------------------------------------------------*/

#define SNSK						B
#define SNS							D
#define QT_DELAY_CYCLES				5

/*
* ײ؂ŎxڐGِ
* ײ؂͂̒lgpč\zA͕ςׂł͂܂B
*/
#define QT_NUM_CHANNELS				8u
/*
* ײ؂Ŏx]Ɛ̍ő吔
* ײ؂͂̒lgpč\zA͕ςׂł͂܂B
*/
#define QT_MAX_NUM_ROTORS_SLIDERS	0u
#define MEASUREMENT_PERIOD_MS		30u
#define POWER_DOWN_PERIOD_MS		75u
#define POWER_ON_PERIOD_MS			20u
#define JOIN( x, y )				x ## y
#define REG( REGISTER, SIDE )		JOIN( REGISTER, SIDE )
#define SENSOR_CONFIG( from, to, type ) ( ( to << 5 ) | ( from << 2 ) | type )
/*
* \ȍő労m퐔̕񍐂ɕKv޲Đ
*/
#define QT_NUM_SENSOR_STATE_BYTES ( ( QT_NUM_CHANNELS + 7 ) / 8 )

/*----------------------------------------------------------------------------
  ^`
----------------------------------------------------------------------------*/

typedef unsigned char uint8_t;
typedef unsigned short uint16_t;
typedef short int16_t;
typedef uint8_t threshold_t;

/* ޯ ްŕԂ銴m^ */
#define SENSOR_TYPE_UNASSIGNED	0x00u
#define SENSOR_TYPE_KEY			0x01u
#define SENSOR_TYPE_ROTOR		0x02u
#define SENSOR_TYPE_SLIDER		0x03u

/*
* ꂩȂΊm킪ǂAKSQɓ邩?
*
* NO_AKS_GROUP = mAKSQɓ炸A}邱Ƃł܂B
* AKS_GROUP_x  = mAKSQxɓ܂B
*/
typedef enum tag_aks_group_t
{
	NO_AKS_GROUP,
	AKS_GROUP_1,
	AKS_GROUP_2,
	AKS_GROUP_3,
	AKS_GROUP_4,
	AKS_GROUP_5,
	AKS_GROUP_6,
	AKS_GROUP_7
} aks_group_t;

/* m */
typedef enum tag_channel_t
{
	CHANNEL_0,
	CHANNEL_1,
	CHANNEL_2,
	CHANNEL_3,
	CHANNEL_4,
	CHANNEL_5,
	CHANNEL_6,
	CHANNEL_7,
} channel_t;
/*
* m팟o˽ؼlB͊m팟o臒l%Ƃĕ\܂B
*
* HYST_x = ˽ؼn͌o臒lx%(؂̂Ċۂ)
* : ŏl2gp܂B
*
* : o臒l=20ȂA
*	  HYST_50	= 10 (2050%)
*	  HYST_25	=  5 (2025%)
*	  HYST_12_5	=  2 (2012.5%)
*	  HYST_6_25	=  2 (206.25%=1Al2ɋ܂B)
*/
typedef enum tag_hysteresis_t
{
	HYST_50,
	HYST_25,
	HYST_12_5,
	HYST_6_25
} hysteresis_t;

/*
* ]ƐɊւāA񍐂px܂͈ʒu̕\
*
* RES_x_BIT = ]/XޯĒlŕ񍐂܂B
*
* : \RES_7_BIT̏ꍇA񍐂ʒu0`127͈̔͂łB
*/
typedef enum tag_resolution_t
{
	RES_1_BIT,
	RES_2_BIT,
	RES_3_BIT,
	RES_4_BIT,
	RES_5_BIT,
	RES_6_BIT,
	RES_7_BIT,
	RES_8_BIT
} resolution_t;
/*
* mčZ臒lB͊m팟o臒l%Ƃĕ\܂B
*
* RECAL_x = čZ臒l͌o臒lx%(؂̂Ċۂ)łB
* : ŏl4gp܂B
*
* : o臒l=40ȂA
*	  RECAL_100  = 40 (40100%)
*	  RECAL_50	 = 20 (4050%)
*	  RECAL_25	 = 10 (4025%)
*	  RECAL_12_5 =  5 (4012.5%)
*	  RECAL_6_25 =  4 (406.25%= 2Al4ɋ܂B)
*/
typedef enum tag_recal_threshold_t
{
	RECAL_100,
	RECAL_50,
	RECAL_25,
	RECAL_12_5,
	RECAL_6_25
} recal_threshold_t;

/* ޯ ްŕԂ */
typedef struct tag_board_info_t
{
	/*
	* IDƉ]/ő吔
	* ޯ3`0 : ID
	* ޯ7`4 : ײ؂Ŏx]܂͐̍ő吔
	*/
	uint8_t qt_max_num_rotors_sliders_board_id;

	/* ײ؂ŎxڐGِ */
	uint8_t qt_num_channels;
} board_info_t;

typedef struct tag_qt_touch_status_t
{
	/*
	* ײ؊m̏(ON/OFF)
	* ޯ'n'=m'n'̏
	* ޯ0 = sensor_states[0]ޯ0
	* ޯ1 = sensor_states[0]ޯ1
	* `
	* ޯ7 = sensor_states[0]ޯ7
	* ޯ8 = sensor_states[1]ޯ0
	* ޯ9 = sensor_states[1]ޯ1
	* ` Ȃ
	* 0=oA1=o
	*/
	uint8_t sensor_states[QT_NUM_SENSOR_STATE_BYTES];

	/*
	* ]px܂͐ʒu
	* ̒lsensor_statesΉ]܂͐oɗLłB
	*/
	uint16_t rotor_slider_values[QT_MAX_NUM_ROTORS_SLIDERS];

} qt_touch_status_t;

/* ڐGmް ------------------------------------------------------------*/
/* ײ؊m̏ */
extern qt_touch_status_t qt_touch_status;

/* eقɑ΂M */
extern uint16_t channel_references[QT_NUM_CHANNELS];

/* eقő肳ꂽM */
extern uint16_t channel_signals[QT_NUM_CHANNELS];

/* (ق琬邩Ȃ)emł̐M */
extern int16_t sensor_deltas[QT_NUM_CHANNELS];

/*============================================================================
 O	: qt_enable_key
------------------------------------------------------------------------------
ړI	: m틖
	: channel			= m킪gpǂꂩ̐ڐG
		  aks_group			= (ǂꂩȂ)m킪ǂꂩAKSQ
		  detect_threshold	= m팟o臒l
		  detect_hysteresis	= m팟o˽ؼl
o	: Ȃ
	: ɑΉ銴m퐔͊m킪鏇ԂɈˑ܂Bŏɋ
		  ꂽm͊m0Am1AȉlłB

		  ݂̌̏(ON/OFF)qt_touch_status.sensor_statesŒׂ邱Ƃ
		  ł܂B
============================================================================*/

void qt_enable_key( channel_t channel,
					aks_group_t aks_group,
					threshold_t detect_threshold,
					hysteresis_t detect_hysteresis );

/*============================================================================
 O	: qt_init_sensing
------------------------------------------------------------------------------
ړI	: ڐGm
	: Ȃ
o	: Ȃ
	: KvȂǂ̊m̊֐ĂԑO(qt_enable_xxx()gp)
		  Ȃ΂Ȃ܂B

		  ̊֐͓ײؕϐvZĐڐGق`Ԑݒ肵AĂ
		  qt_measure_sensors()̑OɌĂ΂Ȃ΂Ȃ܂B
============================================================================*/

void qt_init_sensing( void );

/*============================================================================
 O	: qt_measure_sensors
------------------------------------------------------------------------------
ړI	: ڐGm푪
	: current_time_ms = msł̌ݎ
o	: Ȃ
	: ̊֐͋ꂽmŗeʐs܂Beقɑ΂đ
		  肳ꂽḾǍɎgp҂̐ڐGAJA]pxł̕ωA
		  ʒuł̕ωȂǂɊւĒׂ邽߂ɏ܂B

		  ꂽSĂ̊m݂̌̏Ԃqt_touch_status\̂ŕ񍐂
		  ܂B

		  ̊֐ĂԑOɁA(qt_enable_xxx()gp)1ȏ̊m킪
		  Ȃ΂Ȃ炸Aqt_init_sensing()Ă΂ĂȂ΂Ȃ
		  ܂B
============================================================================*/

void qt_measure_sensors( uint16_t current_time_ms );

#endif /* __MAIN_H__ */
